freeslot(

"MT_RS_SHOT",
"MT_RS_MINISHOT",
"MT_RS_MEGASHOT",

"MT_RS_THROWNAUTOMATIC",

"MT_RS_THROWNBOUNCE",

"MT_RS_THROWNSCATTER",
"S_RS_THROWNSCATTER1",
"S_RS_THROWNSCATTER2",
"S_RS_THROWNSCATTER3",
"S_RS_THROWNSCATTER4",
"S_RS_THROWNSCATTER5",
"S_RS_THROWNSCATTER6",
"S_RS_THROWNSCATTER7",

"MT_RS_THROWNGRENADE",

"MT_RS_THROWNEXPLOSION",

"MT_RS_THROWNSEEKER",
"S_RS_THROWNSEEKER1",
"S_RS_THROWNSEEKER2",
"S_RS_THROWNSEEKER3",
"S_RS_THROWNSEEKER4",
"S_RS_THROWNSEEKER5",
"S_RS_THROWNSEEKER6",
"S_RS_THROWNSEEKER7",
"SPR_THER",
"SPR_RNGM",

"MT_RS_THROWNSPLASH",
"S_RS_THROWNSPLASH1",
"S_RS_THROWNSPLASH2",
"S_RS_SPLASHBOOM",
"SPR_RNGP",
"MT_RS_SPLASH_AOE",

"MT_RS_THROWNACCEL",
"S_RS_THROWNACCEL1",
"S_RS_THROWNACCEL2",
"S_RS_THROWNACCEL3",
"S_RS_THROWNACCEL4",
"SPR_RNGC",

"MT_RS_THROWNWAVE",
"S_RS_THROWNWAVE",
"SPR_RNGW",

"MT_RS_THROWNINFINITY",

//Don't include MT_RS_RAILSHOT in some of the hook stuff
"MT_RS_RAILSHOT"

)

mobjinfo[MT_RS_SHOT] = {
	spawnstate = S_RRNG1,
	deathstate = S_SPRK1,
	deathsound = sfx_rs_die,
	speed = 60*FRACUNIT,
	radius = 16*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_MISSILE|MF_NOGRAVITY,
}
mobjinfo[MT_RS_SHOT].name = "Normal Ring"

mobjinfo[MT_RS_MINISHOT] = {
	spawnstate = S_RRNG1,
	deathstate = S_SPRK1,
	deathsound = sfx_rs_die,
	speed = 65*FRACUNIT,
	radius = 16*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_MISSILE|MF_NOGRAVITY,
}
mobjinfo[MT_RS_MINISHOT].name = "Mini Ring"

mobjinfo[MT_RS_MEGASHOT] = {
	spawnstate = S_RRNG1,
	deathstate = S_SPRK1,
	deathsound = sfx_rs_die,
	speed = 55*FRACUNIT,
	radius = 16*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_MISSILE|MF_NOGRAVITY,
}
mobjinfo[MT_RS_MEGASHOT].name = "Giga Ring"

mobjinfo[MT_RS_THROWNAUTOMATIC] = {
	spawnstate = S_THROWNAUTOMATIC1,
	deathstate = S_SPRK1,
	deathsound = sfx_rs_die,
	speed = 70*FRACUNIT,
	radius = 16*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_MISSILE|MF_NOGRAVITY,
}
mobjinfo[MT_RS_THROWNAUTOMATIC].name = "Automatic Ring"

mobjinfo[MT_RS_THROWNBOUNCE] = {
	spawnstate = S_THROWNBOUNCE1,
	activesound = sfx_rs_bo2,
	deathstate = S_SPRK1,
	deathsound = sfx_rs_die,
	speed = 45*FRACUNIT,
	radius = 16*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_MISSILE|MF_NOGRAVITY|MF_GRENADEBOUNCE|MF_BOUNCE
}
mobjinfo[MT_RS_THROWNBOUNCE].name = "Bounce Ring"

mobjinfo[MT_RS_THROWNSCATTER] = {
	spawnstate = S_RS_THROWNSCATTER1,
	deathstate = S_SPRK1,
	deathsound = sfx_rs_di2,
	speed = 72*FRACUNIT,
	radius = 16*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_MISSILE|MF_NOGRAVITY
}
mobjinfo[MT_RS_THROWNSCATTER].name = "Scatter Ring"

states[S_RS_THROWNSCATTER1] = {
	nextstate = S_RS_THROWNSCATTER2,
	sprite = SPR_RNGS,
	frame = FF_FULLBRIGHT,
	tics = 1,
	action = A_ThrownRing
}
states[S_RS_THROWNSCATTER2] = {
	nextstate = S_RS_THROWNSCATTER3,
	sprite = SPR_RNGS,
	frame = FF_FULLBRIGHT|5,
	tics = 1,
	action = A_ThrownRing
}
states[S_RS_THROWNSCATTER3] = {
	nextstate = S_RS_THROWNSCATTER4,
	sprite = SPR_RNGS,
	frame = FF_FULLBRIGHT|10,
	tics = 1,
	action = A_ThrownRing
}
states[S_RS_THROWNSCATTER4] = {
	nextstate = S_RS_THROWNSCATTER5,
	sprite = SPR_RNGS,
	frame = FF_FULLBRIGHT|15,
	tics = 1,
	action = A_ThrownRing
}
states[S_RS_THROWNSCATTER5] = {
	nextstate = S_RS_THROWNSCATTER6,
	sprite = SPR_RNGS,
	frame = FF_FULLBRIGHT|20,
	tics = 1,
	action = A_ThrownRing
}
states[S_RS_THROWNSCATTER6] = {
	nextstate = S_RS_THROWNSCATTER7,
	sprite = SPR_RNGS,
	frame = FF_FULLBRIGHT|25,
	tics = 1,
	action = A_ThrownRing
}
states[S_RS_THROWNSCATTER7] = {
	nextstate = S_RS_THROWNSCATTER1,
	sprite = SPR_RNGS,
	frame = FF_FULLBRIGHT|30,
	tics = 1,
	action = A_ThrownRing
}

mobjinfo[MT_RS_THROWNGRENADE] = {
	spawnstate = S_THROWNGRENADE1,
	deathstate = S_RINGEXPLODE,
	deathsound = sfx_rs_gr2,
	attacksound = sfx_s3k5c,//beep
	activesound = sfx_s3k5d,//impact
	painchance = 192*FRACUNIT,
	speed = 42*FRACUNIT,
	radius = 16*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_MISSILE|MF_BOUNCE|MF_GRENADEBOUNCE
}
mobjinfo[MT_RS_THROWNGRENADE].name = "Grenade Ring"

mobjinfo[MT_RS_THROWNEXPLOSION] = {
	spawnstate = S_THROWNEXPLOSION1,
	deathstate = S_RINGEXPLODE,
	deathsound = sfx_rs_ex2,
	painchance = 192*FRACUNIT,
	speed = 65*FRACUNIT,
	radius = 16*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_MISSILE|MF_NOGRAVITY
}
mobjinfo[MT_RS_THROWNEXPLOSION].name = "Explosion Ring"

mobjinfo[MT_RS_RAILSHOT] = {
	spawnstate = S_RRNG1,
	deathstate = S_SPRK1,
	deathsound = sfx_rs_die,
	speed = 50*FRACUNIT,
	radius = 16*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_MISSILE|MF_NOGRAVITY,
}
mobjinfo[MT_RS_RAILSHOT].name = "Rail Ring"

mobjinfo[MT_RS_THROWNSEEKER] = {
	spawnstate = S_RS_THROWNSEEKER1,
	deathstate = S_RINGEXPLODE,
	deathsound = sfx_cdfm14,
	painchance = 128*FRACUNIT,
	speed = 35*FRACUNIT,
	radius = 16*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_MISSILE|MF_NOGRAVITY
}
mobjinfo[MT_RS_THROWNSEEKER].name = "Seeker Ring"

states[S_RS_THROWNSEEKER1] = {
	nextstate = S_RS_THROWNSEEKER2,
	sprite = SPR_THER,
	frame = FF_FULLBRIGHT,
	tics = 1,
	action = A_ThrownRing
}
states[S_RS_THROWNSEEKER2] = {
	nextstate = S_RS_THROWNSEEKER3,
	sprite = SPR_THER,
	frame = FF_FULLBRIGHT|1,
	tics = 1,
	action = A_ThrownRing
}
states[S_RS_THROWNSEEKER3] = {
	nextstate = S_RS_THROWNSEEKER4,
	sprite = SPR_THER,
	frame = FF_FULLBRIGHT|2,
	tics = 1,
	action = A_ThrownRing
}
states[S_RS_THROWNSEEKER4] = {
	nextstate = S_RS_THROWNSEEKER5,
	sprite = SPR_THER,
	frame = FF_FULLBRIGHT|3,
	tics = 1,
	action = A_ThrownRing
}
states[S_RS_THROWNSEEKER5] = {
	nextstate = S_RS_THROWNSEEKER6,
	sprite = SPR_THER,
	frame = FF_FULLBRIGHT|4,
	tics = 1,
	action = A_ThrownRing
}
states[S_RS_THROWNSEEKER6] = {
	nextstate = S_RS_THROWNSEEKER7,
	sprite = SPR_THER,
	frame = FF_FULLBRIGHT|5,
	tics = 1,
	action = A_ThrownRing
}
states[S_RS_THROWNSEEKER7] = {
	nextstate = S_RS_THROWNSEEKER1,
	sprite = SPR_THER,
	frame = FF_FULLBRIGHT|6,
	tics = 1,
	action = A_ThrownRing
}

local A_SplashBoom = function(mo)
	for i = 0, 15
		local fa = i*(ANGLE_180/8)
		local mobj = P_SpawnMobjFromMobj(mo,0,0,0,MT_RS_SPLASH_AOE)
		if mobj and mobj.valid
			mobj.destscale = mobj.scale * 2
			mobj.sprite = SPR_BUBL
			mobj.frame = $ + (B | FF_FULLBRIGHT)
			mobj.target = mo.target
			mobj.fuse = TICRATE/2
			mobj.tics = mobj.fuse
			mobj.color = mo.color
			mobj.colorized = true
			mobj.momz = FixedMul(sin(fa),mo.scale * 5)
			P_InstaThrust(mobj, mo.angle+ANGLE_90,FixedMul(cos(fa),mo.scale * 5))
			P_Thrust(mobj, mo.angle, mo.scale)
		end
	end
	RingSlinger.RocketForce(mo, 13)
end
states[S_RS_THROWNSPLASH1] = {
	nextstate = S_RS_THROWNSPLASH2,
	sprite = SPR_RNGP,
	frame = FF_FULLBRIGHT,
	tics = 1,
	action = A_ThrownRing
}
states[S_RS_THROWNSPLASH2] = {
	nextstate = S_RS_THROWNSPLASH1,
	sprite = SPR_RNGP,
	frame = FF_FULLBRIGHT|1,
	tics = 1,
	action = A_ThrownRing
}
states[S_RS_SPLASHBOOM] = {
	nextstate = S_SPRK1,
	sprite = SPR_RNGP,
	frame = FF_FULLBRIGHT,
	tics = 0,
	action = A_SplashBoom
}
mobjinfo[MT_RS_THROWNSPLASH] = {
	spawnstate = S_RS_THROWNSPLASH1,
	deathstate = S_RS_SPLASHBOOM,
	deathsound = sfx_rs_sp2,
	speed = 90*FRACUNIT,
	radius = 16*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_MISSILE|MF_NOGRAVITY
}
mobjinfo[MT_RS_THROWNSPLASH].name = "Splash Ring"

mobjinfo[MT_RS_SPLASH_AOE] = {
	spawnstate = S_THOK,
	radius = 16*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_MISSILE|MF_NOGRAVITY,
}
mobjinfo[MT_RS_SHOT].name = "Splash Ring"

mobjinfo[MT_RS_THROWNACCEL] = {
	spawnstate = S_RS_THROWNACCEL1,
	deathstate = S_SPRK1,
	deathsound = sfx_rs_di2,
	speed = 22*FRACUNIT,
	radius = 16*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_MISSILE|MF_NOGRAVITY
}
mobjinfo[MT_RS_THROWNACCEL].name = "Accel Ring"

states[S_RS_THROWNACCEL1] = {
	nextstate = S_RS_THROWNACCEL2,
	sprite = SPR_RNGC,
	frame = FF_FULLBRIGHT,
	tics = 1,
	action = A_ThrownRing
}
states[S_RS_THROWNACCEL2] = {
	nextstate = S_RS_THROWNACCEL3,
	sprite = SPR_RNGC,
	frame = FF_FULLBRIGHT|1,
	tics = 1,
	action = A_ThrownRing
}
states[S_RS_THROWNACCEL3] = {
	nextstate = S_RS_THROWNACCEL4,
	sprite = SPR_RNGC,
	frame = FF_FULLBRIGHT|2,
	tics = 1,
	action = A_ThrownRing
}
states[S_RS_THROWNACCEL4] = {
	nextstate = S_RS_THROWNACCEL1,
	sprite = SPR_RNGC,
	frame = FF_FULLBRIGHT|3,
	tics = 1,
	action = A_ThrownRing
}

mobjinfo[MT_RS_THROWNWAVE] = {
	spawnstate = S_RS_THROWNWAVE,
	deathstate = S_SPRK1,
	deathsound = sfx_rs_di2,
	speed = 50*FRACUNIT,
	radius = 16*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_MISSILE|MF_NOGRAVITY
}
mobjinfo[MT_RS_THROWNWAVE].name = "Wave Ring"

states[S_RS_THROWNWAVE] = {
	nextstate = S_RS_THROWNWAVE,
	sprite = SPR_RNGW,
	frame = FF_FULLBRIGHT,
	tics = 1,
	action = A_ThrownRing
}

//THIS MOBJ SHOULD BE THE LAST ONE, BECAUSE OF THE LOOP IN WEAPONHOOKS
mobjinfo[MT_RS_THROWNINFINITY] = {
	spawnstate = S_THROWNINFINITY1,
	deathstate = S_SPRK1,
	deathsound = sfx_rs_die,
	speed = 65*FRACUNIT,
	radius = 16*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_MISSILE|MF_NOGRAVITY
}
mobjinfo[MT_RS_THROWNINFINITY].name = "Infinity Ring"